<template>
  <AppModal
    name-modal="modal-abstract-table"
    :width-modal="586"
    :visible="visible"
    :gray-header="true"
    @before-close="beforeClose"
    init-class="modalApplicability">
    <div
      slot="header"
      class="modalApplicability-header">
      <div class="heading _h4">
        <slot name="header-content"/>
      </div>
      <div class="input -action-search">
        <input
          class="input-field"
          type="text"
          placeholder="Марка, модель или модификация"
          @input="onInput">
        <span class="input-action _search">
          <img
            svg-inline
            src="~/assets/svg/redesign/magnifer-bold.svg">
        </span>
      </div>
    </div>

    <div
      slot="body"
      class="abstractTable">
      <div class="abstractTable-content">
        <div class="thead">
          <div class="tr">
            <div
              v-for="(heading, i) in headings"
              :key="`table-th-${i}`"
              :class="`th _${heading.name}`">
              <template v-if="heading.sorting.has">
                <!-- Классы для направления сортировки: -sorting-up / -sorting-down -->
                <button
                  class="table-button-sorting"
                  :class="sortClasses[heading.sorting.criteria]"
                  @click="orderChange(heading.sorting.criteria)">
                  <span>{{ heading.title }}</span>
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/sorting-none.svg">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/sorting.svg">
                </button>
              </template>
              <template v-else>
                {{ heading.title }}
              </template>
            </div>
          </div>
        </div>
        <div class="tbody">
          <div
            class="tr"
            v-for="(entity, j) in filteredEntities"
            :key="`${entity[fields[0]] + j}`">
            <div
              class="td"
              v-for="(heading, k) in headings"
              :key="`heading-${j}-${k}`"
              :class="`_${heading.name}`">
              <slot
                :name="`unit-${heading.name}`"
                :entity="entity"/>
            </div>
          </div>
        </div>
        <div
          class="tfooter"
          v-show="!filteredEntities.length">
          <slot name="footer-content"/>
        </div>
      </div>
    </div>
  </AppModal>
</template>

<script>
import { isEmpty, orderBy, has } from 'lodash-es';
import AppModal from '~/components/redesign/app-modals/app-modal';
import AppButton from '~/components/redesign/app-buttons/app-button';
import Modals from '~/assets/js/mixins/redesign/modals';

export default {
  name: 'AppModalAbstractTable',
  components: {
    AppModal,
    AppButton,
  },
  mixins: [Modals],
  props: {
    headings: {
      type: Array,
      default() {
        return [];
      },
    },
    entities: {
      type: Array,
      default() {
        return [];
      },
    },
    fields: {
      type: Array,
      default() {
        return [];
      },
    },
  },
  data() {
    return {
      searchString: '',
      order: {
        field: this.fields[0],
        direction: 'asc',
      },
      queries: [],
    };
  },
  computed: {
    filteredEntities() {
      return orderBy(this.entities, [this.order.field], [this.order.direction])
        .filter(item => isEmpty(this.queries) || this.hasMatch(item));
    },
    sortClasses() {
      const direction = Object.assign({}, this.$options.direction);

      if (has(direction, this.order.field)) {
        direction[this.order.field] = (this.order.direction === 'asc' ? '-sorting-up' : '-sorting-down');
      }

      return direction;
    },
  },
  created() {
    this.$options.direction = this.fields.reduce((acc, currentField) => {
      acc[currentField] = 'none';
      return acc;
    }, {});
  },
  methods: {
    onInput(value) {
      this.queries = value.target.value.trim().split(/\s+/);
      this.$emit('input', this.queries);
    },
    orderChange(field) {
      const newOrder = {
        field,
        direction: 'asc',
      };

      if (field === this.order.field) {
        newOrder.direction = this.order.direction === 'asc' ? 'desc' : 'asc';
      }
      this.order = newOrder;
    },

    hasSubstring(string, substring) {
      return string.toLowerCase().includes(substring.toLowerCase());
    },
    hasMatch(entity) {
      // TODO: Нужен цикл по fields
      return this.queries.some(query => this.hasSubstring(entity[this.fields[0]], query))
        || this.queries.some(query => this.hasSubstring(entity[this.fields[1]], query))
        || this.queries.some(query => this.hasSubstring(entity[this.fields[2]], query));
    },
    beforeClose() {
      this.searchString = '';
      this.queries = [];
      this.$emit('close');
      this.$emit('input', this.queries);
    },
  },
};
</script>

<style lang="postcss">
  @import "~/assets/css/components/abstract-table.css";

  .modalApplicability {
    &-header {
      display: flex;
      width: 100%;
    }

    .abstractTable {
      .tr {
        .th, .td {
          min-width: 33.333%;
        }

        /*AlexCzech*/
        .td > span {
          max-width: 9.875rem;
          text-overflow: ellipsis;
          white-space: nowrap;
          overflow: hidden;
        }
      }

      .tfooter {
        padding: 1.5rem;
        text-align: center;
      }
    }
  }

  @media screen and (max-width: 980px) {
    .searchByNumber-applicability {
      position: relative;

      .v--modal-overlay {
        position: static;
        height: auto;
        background: none;
      }

      .modalApplicability {
        box-shadow: none;
        &-header {
          flex-direction: column;
        }

        .appModal-header {
          padding: 1rem 1.25rem;
          border-bottom: 1px solid var(--border-color-main);

          .heading {
            font-size: 1.125rem;
            font-weight: var(--font-weight-medium);
            text-align: left;
            padding-bottom: 1rem;
          }

          .input-field {
            font-size: 1rem;
          }
        }

        .appModal-close-button {
          display: none;
        }

        .abstractTable .tbody {
          height: auto;
          max-height: none;
          overflow: visible;
        }

      }
    }

    /*AlexCzech Workaround пока не сделали компонент*/
    [data-modal="modal-abstract-table"].v--modal-overlay {
      & .v--modal-box {
        position: static;
      }
    }
  }

</style>
